/* $Id:
 *
 * COPYRIGHT:       See COPYING in the top level directory
 * PROJECT:         ReactOS kernel
 * FILE:            drivers/dd/serial/close.c
 * PURPOSE:         Serial IRP_MJ_CLOSE operations
 *
 * PROGRAMMERS:     Hervé Poussineau (poussine@freesurf.fr)
 */

#include <ddk/ntddk.h>
#define DEBUG
#include <debug.h>

// config and include core/hcd.h, for hc_device struct
#include "../usb_wrapper.h"
#include "../core/hcd.h"

#include "../host/ohci_main.h"



NTSTATUS STDCALL
UhciClose(
	IN PDEVICE_OBJECT DeviceObject,
	IN PIRP Irp)
{
	POHCI_DEVICE_EXTENSION pDeviceExtension;

	DPRINT1("UHCI: IRP_MJ_CLOSE\n");
	pDeviceExtension = (POHCI_DEVICE_EXTENSION)DeviceObject->DeviceExtension;
	InterlockedDecrement((PLONG)&pDeviceExtension->DeviceOpened);

	Irp->IoStatus.Information = 0;
	Irp->IoStatus.Status = STATUS_SUCCESS;
	IoCompleteRequest(Irp, IO_NO_INCREMENT);
	return STATUS_SUCCESS;
}
